<template>
  <div style="margin-top: 20px">
    <v-container class="fill-height">
      <v-row align="center" justify="center">
        <v-col cols="12" md="12" xl="12" sm="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">search</v-icon>
                ค้นหา
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-card-text>
              <FilterLocker v-model="obj" :role="role" />
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="orange"
                dark
                depressed
                @click="fetchLocker('reset')"
              >
                <v-icon left> search </v-icon>
                ค้นหา
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col>
          <v-card>
            <v-card-text>
              <!-- Title -->
              <v-toolbar flat>
                <v-toolbar-title>
                  <v-icon color="info" class="mx-2">content_paste</v-icon>
                  รายการเพิ่มล็อกเกอร์
                </v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>
                <v-btn
                  color="info"
                  :to="{ name: 'locker-request' }"
                  v-if="role == 'Partner'"
                  depressed
                >
                  <v-icon>description</v-icon> เพิ่มล็อกเกอร์
                </v-btn>
              </v-toolbar>
              <br />

              <Loading
                v-if="loading"
                :propLoading="loading"
                propText="กรุณารอสักครู่"
              />
              <!-- Table -->
              <TableLocker
                :role="role"
                :items="items"
                :loading="loading"
                v-show="!loading"
                @update-table-parent="updateParentData"
              />
              <div class="text-center my-1" v-if="items.length > 0">
                <v-pagination
                  v-model="page"
                  :length="length"
                  :total-visible="7"
                  circle
                  @input="handlePageChange"
                  v-show="!loading"
                >
                </v-pagination>
              </div>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import FilterLocker from "../../../components/locker/FilterLocker";
import TableLocker from "../../../components/locker/TableLocker";
import Loading from "../../../components/loading/Loading";
import { LockerModel } from "./model/locker";
export default {
  components: {
    FilterLocker,
    TableLocker,
    Loading,
  },
  data() {
    return {
      obj: {},
      page: 1,
      perPage: 5,
      loading: true,
      length: null,
      items: [],
      role: this.$store.getters["auth/roleUser"],
    };
  },
  async created() {
    await this.fetchLocker();
  },
  methods: {
    async handlePageChange(value) {
      this.page = value;
      await this.fetchLocker();
    },
    updateParentData(i) {
      if (i) this.fetchLocker();
    },
    async fetchLocker(text) {
      let param = LockerModel.lockerParam(
        text,
        this.obj,
        this.page,
        this.perPage,
        this.role
      );
      this.page = param.page;
      await this.$store.dispatch("locker/getAllFormAdmin", param);
      let res = this.$store.getters["locker/formList"];
      let loading = this.$store.getters["locker/loading"];
      this.items = res.content;
      this.length = res.length;
      this.loading = loading;
    },
  },
};
</script>

<style>
</style>